/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import java.util.ArrayList;

public final class IntMatrix {
    private int colCount = 0;
    private int rowCount = 0;
    private ArrayList rowList = new ArrayList(0);

    public IntMatrix() {
    }

    public IntMatrix(int colCount, int rowCount) {
        this.reset(colCount, rowCount);
    }

    public void clear() {
        this.rowList.clear();
        this.colCount = 0;
        this.rowCount = 0;
    }

    public void reset(int newColCount, int newRowCount) {
        this.clear();
        this.setColCount(newColCount);
        this.setRowCount(newRowCount);
    }

    public int getColCount() {
        return this.colCount;
    }

    public void setColCount(int newColCount) {
        if (this.colCount == newColCount) {
            return;
        }
        int count = this.colCount <= newColCount ? this.colCount : newColCount;
        int i = 0;
        while (i < this.rowCount) {
            int[] oldRow = (int[])this.rowList.get(i);
            int[] newRow = new int[newColCount];
            int j = 0;
            while (j < count) {
                newRow[j] = oldRow[j];
                ++j;
            }
            this.rowList.set(i, newRow);
            ++i;
        }
        this.colCount = newColCount;
    }

    public int getRowCount() {
        return this.rowCount;
    }

    public void setRowCount(int newRowCount) {
        if (this.rowCount == newRowCount) {
            return;
        }
        int i = this.rowCount - 1;
        while (i >= newRowCount) {
            this.rowList.remove(i);
            --i;
        }
        i = this.rowCount;
        while (i < newRowCount) {
            this.rowList.add(new int[this.colCount]);
            ++i;
        }
        this.rowCount = newRowCount;
    }

    public int get(int x, int y) {
        int[] aRow = (int[])this.rowList.get(y);
        return aRow[x];
    }

    public void set(int x, int y, int value) {
        int[] aRow = (int[])this.rowList.get(y);
        aRow[x] = value;
    }

    public void insertCol(int index) {
        int i = 0;
        while (i < this.rowCount) {
            int[] oldRow = (int[])this.rowList.get(i);
            int[] newRow = new int[this.colCount + 1];
            int j = 0;
            while (j < index) {
                newRow[j] = oldRow[j];
                ++j;
            }
            j = index;
            while (j < this.colCount) {
                newRow[j + 1] = oldRow[j];
                ++j;
            }
            ++i;
        }
        ++this.colCount;
    }

    public void deleteCol(int index) {
        int i = 0;
        while (i < this.rowCount) {
            int[] oldRow = (int[])this.rowList.get(i);
            int[] newRow = new int[this.colCount - 1];
            int j = 0;
            while (j < index) {
                newRow[j] = oldRow[j];
                ++j;
            }
            j = index + 1;
            while (j < this.colCount) {
                newRow[j - 1] = oldRow[j];
                ++j;
            }
            ++i;
        }
        --this.colCount;
    }

    public void exchangeCol(int index1, int index2) {
        int i = 0;
        while (i < this.rowCount) {
            int[] aRow = (int[])this.rowList.get(i);
            int T = aRow[index1];
            aRow[index1] = aRow[index2];
            aRow[index2] = T;
            ++i;
        }
    }

    public void moveCol(int index1, int index2) {
        if (index1 == index2) {
            return;
        }
        int i = 0;
        while (i < this.rowCount) {
            int j;
            int[] aRow = (int[])this.rowList.get(i);
            int T = aRow[index1];
            if (index1 > index2) {
                j = index1 - 1;
                while (j >= index2) {
                    aRow[j + 1] = aRow[j];
                    --j;
                }
            } else if (index1 < index2) {
                j = index1 + 1;
                while (j < index2) {
                    aRow[j - 1] = aRow[j];
                    ++j;
                }
            }
            aRow[index2] = T;
            ++i;
        }
    }

    public void insertRow(int index) {
        this.rowList.add(index, new int[this.colCount]);
        ++this.rowCount;
    }

    public void deleteRow(int index) {
        this.rowList.remove(index);
        --this.rowCount;
    }

    public void exchangeRow(int index1, int index2) {
        int[] aRow = (int[])this.rowList.get(index1);
        this.rowList.set(index1, this.rowList.get(index2));
        this.rowList.set(index2, aRow);
    }

    public void moveRow(int index1, int index2) {
        int[] aRow = (int[])this.rowList.get(index1);
        if (index1 > index2) {
            int i = index1 - 1;
            while (i >= index2) {
                this.rowList.set(i + 1, this.rowList.get(i));
                --i;
            }
        } else if (index1 < index2) {
            int i = index1 + 1;
            while (i < index2) {
                this.rowList.set(i - 1, this.rowList.get(i));
                ++i;
            }
        }
        this.rowList.set(index2, aRow);
    }
}

